"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = __importStar(require("underscore"));
const ck_lib_1 = require("@ckstack/ck-lib");
const DatabaseService_1 = __importDefault(require("./DatabaseService"));
class DatabaseWebService {
    static getDataOneById_AOP(req, res, TCreator, id, attributes, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDataOneById(lhd, TCreator, id, attributes, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDatasByIds_AOP(req, res, TCreator, ids, attributes, transaction, order) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDatasByIds(lhd, TCreator, ids, attributes, transaction, order);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static countDatasByIds_AOP(req, res, TCreator, ids, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.countDatasByIds(lhd, TCreator, ids, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDataOneByRid_AOP(req, res, TCreator, rid, attributes, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDataOneByRid(lhd, TCreator, rid, attributes, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDatasByRids_AOP(req, res, TCreator, rids, attributes, transaction, order) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDatasByRids(lhd, TCreator, rids, attributes, transaction, order);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static countDatasByRids_AOP(req, res, TCreator, rids, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.countDatasByRids(lhd, TCreator, rids, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDataOneByFilter_AOP(req, res, TCreator, filter, attributes, transaction, order) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDataOneByFilter(lhd, TCreator, filter, attributes, transaction, order);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDatasByFilter_AOP(req, res, TCreator, filter, attributes, transaction, order, offset, limit) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDatasByFilter(lhd, TCreator, filter, attributes, transaction, order, offset, limit);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static countDatasByFilter_AOP(req, res, TCreator, filter, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.countDatasByFilter(lhd, TCreator, filter, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDataMapByKeyArray_AOP(req, res, keys, VCreator, colName, mapKey, cols, toCond, transaction) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDataMapByKeyArray(lhd, keys, VCreator, colName, mapKey, cols, toCond, transaction);
            return ret;
        });
    }
    static changeListOrder_AOP(req, res, rdb, TCreator, rawQuery, replacements, srcId, srcListOrder, destListOrder, transaction) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.changeListOrder(lhd, rdb, TCreator, rawQuery, replacements, srcId, srcListOrder, destListOrder, transaction);
            return ret;
        });
    }
    static changeListOrderV2_AOP(req, res, rdb, TCreator, srcRid, destRid, rawQueryPart, replacements, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.changeListOrderV2(lhd, rdb, TCreator, srcRid, destRid, rawQueryPart, replacements, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static createDataWithListOrder_AOP(req, res, TCreator, newData, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.createDataWithListOrder(lhd, TCreator, newData, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static createData_AOP(req, res, newData, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.createData(lhd, newData, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static updateData_AOP(req, res, TCreate, modData, where, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.updateData(lhd, TCreate, modData, where, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static deleteData_AOP(req, res, TCreate, where, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.deleteData(lhd, TCreate, where, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static incrementData_AOP(req, res, TCreate, where, cols, by, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.incrementData(lhd, TCreate, where, cols, by, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
        });
    }
    static getDataByRawQuery_AOP(req, res, rawQuery, rdb, replacements, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDataByRawQuery(lhd, rawQuery, rdb, replacements, transaction);
            if (_.isString(ret)) {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static addMandatoryColumns(columnNames, attributes) {
        return DatabaseService_1.default.addMandatoryColumns(columnNames, attributes);
    }
}
exports.default = DatabaseWebService;
